function Tpsi=create_gfT_auto(w,Z,O,MD,M,Ind);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global expo
global observations
global phi
global X
global Y

observations=Z;
X=real(observations);
Y=imag(observations);

Neq=size(MD,1);
expo=exp(real(w'*Z));
phi=mean(expo);
nbc=length(w);

Ncomb=nbc^O;

for p=1:Ncomb
    k=floor((p-1)/(nbc^(O-1)))+1;
    index(p,O)=k;
        y=index(p,O);
        x=p;
        for o=O-1:-1:1
            x=x-(y-1)*nbc^o;
            index(p,o)=floor((x-1)/(nbc^(o-1)))+1;
            y=index(p,o);
        end  
        Tpsi(p,:)=derive(MD,index(p,:),M,Ind);
end

    Tpsi=reshape(Tpsi,[nbc*ones(1,O) Neq]);



function V=derive(MD,index,M,ind)
global phi
for neq=1:size(MD,1)
    V2=0;
    for os=1:size(M,1)
        Ophi=nnz(M(os,:));
        V1=factorial(Ophi-1)*(-1)^(Ophi-1)/phi^Ophi;
        deb=1;
        for op=1:Ophi
            fin=deb+M(os,op)-1;
            indp1=ind(os,deb:fin);
            indp=index(indp1);
            V1=V1*D(indp,MD(neq,:),indp1);
            deb=fin+1;
        end
        V2=V2+V1;
    end
    V(neq)=V2;  
end
    
    
 function t=D(indD,indeq,indp1);
global expo
global X
global Y
x=ones(1,size(X,2));
for i=1:length(indD)
    if indeq(indp1(i))==0
        x=x.*X(indD(i),:);
    else
        x=x.*Y(indD(i),:);
    end
end
t=mean(x.*expo);
    

