function [TB]=model_caf_C3(L);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A=L{1};
B=L{2};
G1=L{3};
G2=L{4};
G3=L{5};

% T1(:,:,1)=A;
% T1(:,:,2)=B;
% T2(:,:,1)=G1;
% T2(:,:,2)=G2;
% T2(:,:,3)=G3;
K=size(A,2);
R=size(G1,1);

N=size(A,1);
% P=zeros(2,2,3,4);
% TA=zeros(N,N,R,4);
% P(1,1,1,1)=1;
% P(1,2,2,1)=-1;
% P(2,1,2,1)=-1;
% P(2,2,3,1)=1;
% 
% P(1,1,3,2)=1;
% P(1,2,2,2)=1;
% P(2,1,2,2)=1;
% P(2,2,1,2)=1;
% 
% P(1,1,2,3)=1;
% P(1,2,1,3)=1;
% P(2,1,3,3)=-1;
% P(2,2,2,3)=-1;
% 
% P(1,1,2,4)=1;
% P(1,2,3,4)=-1;
% P(2,1,1,4)=1;
% P(2,2,2,4)=-1;
% 
% for s=1:4
%     for r=1:R
%         for p=1:N
%             for q=1:N
%                 for l=1:2
%                     for m=1:2
%                         for n=1:3
%                             for k=1:K
%                                  TA(p,q,r,s)=TA(p,q,r,s)+T1(p,k,l)*T1(q,k,m)*T2(r,k,n)*P(l,m,n,s);
%                             end
%                         end
%                     end
%                 end
%             end
%         end
%     end
% end

%TB=zeros(N,N,R,4);
TB=zeros(N,N,R,3);
TB(:,:,:,1)=tenseur({A,A,G1})-tenseur({A,B,G2})-tenseur({B,A,G2})+tenseur({B,B,G3});
TB(:,:,:,2)=tenseur({B,B,G1})+tenseur({B,A,G2})+tenseur({A,B,G2})+tenseur({A,A,G3});
TB(:,:,:,3)=tenseur({A,B,G1})+tenseur({A,A,G2})-tenseur({B,B,G2})-tenseur({B,A,G3});

%TB=squeeze(TB(:,:,:,1));

%TB(:,:,:,4)=tenseur({B,A,G1})-tenseur({B,B,G2})+tenseur({A,A,G2})-tenseur({A,B,G3});

% a=(TA-TB);
% max(abs(a(:)));




