function [T,MG]=model_caf_auto(L,M,mg);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
O=size(M,2);
Np=size(M,1);
a=L{3};
R=size(a,1);
b=L{1};
N=size(b,1);
dimTd=[Np*N N*ones(1,O-1) R];
dimT=[Np N*ones(1,O) R];
T=[];
for i=1:Np
    ind=M(i,:);
    [S,MG1]=equa(ind,L,mg);
    T1=reshape(S,[1 N*ones(1,O) R]);
    T=[T;T1];  
    if mg==1
      for g=1:length(L)-2 
        MG{g}(i,:,:)=MG1{g};
      end
    end   
end
T=shiftdim(T,1);

    
