function Ln=permscal3(L,Lv);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Removes the permutation and the scaling indeterminancy in the loading
% matrices stored in L from the real matrices stored in Lv 


N=length(L);
F=size(L{1},2);
X=[];
Xv=[];


for n=1:N
    A=L{n};
    Av=Lv{n};
    for i=1:F
        s=sum(A(:,i));
        An(:,i)=A(:,i)/s;
        s=sum(Av(:,i));
         Avn(:,i)=Av(:,i)/s;
    end
    X=[X;An];
    Xv=[Xv;Avn];
end


P=perms(1:F);

for i=1:size(P,1)
    r(i)=norm(Xv-X(:,P(i,:)));
end
[m,pos]=min(r);
p=P(pos,:);
Ln=L;

for n=1:N
    A=L{n}(:,p);
    Av=Lv{n};
    for i=1:F
        s=sum(A(:,i))/sum(Av(:,i));
        Ae(:,i)=A(:,i)/s;
    end
    Ln{n}=Ae;
end
        
        
        


