function [Ln,res]=boucle_als(L,T);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, Andr L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%effectue l'tape n de l'estimation des matrices (Ln{1}, Ln{2}... Ln{D})  partir
%des rsultats de l'tape n-1 (L{1}, L{2}... L{D}) 
I=size(T); % tensor dimensions
D=length(I); % tensor order (number of dimensions)
Ln=L;
TT=T;
d2=[1 D:-1:2];%ordre des matrices dans le calcule des produits de khatri rao (premier passage)
ind=[1:D];
%On effectue l'estimation de chaque matrice (de 1  D)
for d1=1:D
    I=size(TT);
    %produit de khatri rao entre les diffrentes matrices que l'on a pas 
    %estimer  ce passage dans la boucle
    Z=Ln{d2(2)};
    
    for d=d2(3:end)
        Z=pkr(Z,Ln{d});
    end      
    %On dplie le tenseur dans le sens adequat (correspondant  la matrice
    % estimer)
    Td=reshape(TT,[I(1) prod(I(2:end))]);
   %estimation de la matrice
    a=pinv(Z)*Td.';
     Ln{d1}=a.';
    %permutation circulaire du des dimensions du tenseur (mise  jour du
    %sens de dpliement du tenseur)
    ind=circshift(ind,[0 -1]);
    TT=permute(T,ind);
    %permutation du jeu d'indice pour le produit de khatri rao
    %(mise  jour de l'ordre des matrices dans le calcule des produits de khatri rao lors du prochain passage)
    d2=circshift(d2,[0,1]); 
    %
end
%calcul de l'nergie de l'erreur de reconstruction (res)

I=size(TT);
Td=reshape(TT,[I(1) prod(I(2:end))]);
Z=Ln{d2(2)};
for d=d2(3:end)
    Z=pkr(Z,Ln{d});
end
TTe=Ln{1}*Z.';
res=Td(:)-TTe(:);
res=res'*res/sum((Td(:)).^2);
