function C=coefpolykr(K,N,F);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%permet de calculer les matrices coefficients du polynome en R obtenu avec
%le pkr sur toutes les matrices sauf la matrice courante
%N=produit des nombre de lignes des matrices qui sont utilis�s dans le pkr
%F nombre de colonnes des matrices (nb de facteurs)
%D: nombre de matrices (ordre du tenseur)
D=size(K,1);
ind=ones(1,D-1);
C={};
for d1=1:D
    C{D-d1+1}=zeros(N,F);
    ind(1:d1-1)=2;
    for d2=1:nchoosek(D-1,d1-1)
        C{D-d1+1}=C{D-d1+1}+pkrec(K,ind);
         %C{d1}=C{d1}+pkrec(K,ind);
        ind=circshift(ind,[0,1]);
    end
end


function Z=pkrec(L,ind);

Z=L{size(L,1),ind(1)};
for d=size(L,1)-1:-1:2
    Z=pkr(Z,L{d,ind(d)});%ind(d-1)
end
