function g=construct_gradient3(L,T)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, Andr L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%construction du gradient de la fonction de cot du modle PARAFAC en
%utilisant une boucle (plus long mais moins gourmand en mmoire).
R=tenseur(L)-T;
I=size(T);
D=length(I);
N=size(L{1},2);
g=zeros(N*sum(I),1);
k=1;
for i=1:I(1)
    for n=1:N
        M=(L{2}(:,n))*(L{3}(:,n))';
        Tn=squeeze(R(i,:,:)).*M;
        g(k)=sum(Tn(:));
        k=k+1;
    end
end

for i=1:I(2)
    for n=1:N
        M=(L{1}(:,n))*(L{3}(:,n))';
        Tn=squeeze(R(:,i,:)).*M;
        g(k)=sum(Tn(:));
        k=k+1;
    end
end

for i=1:I(3)
    for n=1:N
        M=(L{1}(:,n))*(L{2}(:,n))';
        Tn=squeeze(R(:,:,i)).*M;
        g(k)=sum(Tn(:));
        k=k+1;
    end
end
