function [Hes,Jac]=construct_hessian(L,T)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I=size(T);
D=length(I);
nbs=size(L{1},2);
TT=T;
d=1:D;

% initialize Jacobian and Hessian matrices
Jac= zeros(prod(I),sum(I)*nbs);
Hes= zeros(nbs,nbs);

k=1;
for i=1:D
    
    d=circshift(d,[0,-1]);
       
    Z=ones(1,nbs);
    for j=1:D-1 
        Z=pkr(L{d(j)},Z);
    end
    
    PI=permut_matrices(I,d);
         
    Jac(:,k:k-1+I(i)*nbs)= PI*kron(I_(I(i)),Z);
    
    k=k + I(i)*nbs;

end
Hes=Jac'*Jac;
