function Tpsi=create_gfT_4r(u,X);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global expo
global observations
observations=X;

expo=exp(u.'*X);
phi=mean(expo);
N=length(u);

for ii=1:N
    for j=1:N
        for k=1:N
            for l=1:N
                Tpsi(ii,j,k,l)=D([ii j k l])/phi ...
                      -(D([ii j k])*D(l)+D([ii j l])*D(k)+D([ii k l])*D(j)+D([j k l])*D(ii))/phi^2 ...
                      -(D([ii j])*D([k l])+D([ii k])*D([j l])+D([j k])*D([ii l]))/phi^2 ...
                      +2*(D([ii j])*D(k)*D(l)+D([ii k])*D(j)*D(l)+D([j k])*D(ii)*D(l)+D([l ii])*D(j)*D(k)+D([j l])*D(k)*D(ii)+D([k l])*D(ii)*D(j))/phi^3 ...
                      -6*(D(ii)*D(j)*D(k)*D(l))/phi^4;
            end
        end
    end
end


function t=D(ind);
global expo
global observations


x=prod(observations(ind,:),1);
t=mean(x.*expo);

    








