function [p,res]=els(T,K,N,F);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Perform the enhanced line search
%p is the optimal step

C=coefpolykr(K,N,F);
C=polymat(({K{1,2},K{1,1}}),C,0,-1);
C{1}=T.'+C{1};
C=polymat((C),C,1);
Cd=fliplr(C(2:end).*[1:length(C)-1]);
P=real(roots(Cd'));
res1=polyval(fliplr(C),P);
[a,b]=min(abs(res1));
res=a/sum((T(:)).^2);
b;
p=P(b);


    
    
    
