function Tpsi=create_gfT_2(w,Z);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global expo
global observations

observations=Z;

expo=exp(real(w'*Z));
phi=mean(expo);
nbc=length(w);
Tpsi=zeros(nbc,nbc,3);
for p=1:nbc
    for q=1:nbc
        Tpsi(p,q,:)=derive(p,q);       
    end
end


function V=derive(p,q);
global expo
global observations
phi=mean(expo);

X=real(observations);
Y=imag(observations);
V(1)=(mean(X(p,:).*X(q,:).*expo)/phi)-(mean(X(p,:).*expo)*mean(X(q,:).*expo)/(phi^2));
V(2)=(mean(Y(p,:).*Y(q,:).*expo)/phi)-(mean(Y(p,:).*expo)*mean(Y(q,:).*expo)/(phi^2));
V(3)=(mean(X(p,:).*Y(q,:).*expo)/phi)-(mean(X(p,:).*expo)*mean(Y(q,:).*expo)/(phi^2));



