function Tpsi=create_gfT_3(w,Z);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global expo
global observations

observations=Z;

expo=exp(real(w'*Z));
phi=mean(expo);
nbc=length(w);
Tpsi=zeros(nbc,nbc,nbc,4);
for p=1:nbc
    for q=1:nbc
        for r=1:nbc
            Tpsi(p,q,r,:)=derive(p,q,r);
        end
    end
end


function V=derive(p,q,r);
global expo
global observations
phi=mean(expo);

X=real(observations);
Y=imag(observations);
V(1)=(mean(X(p,:).*X(q,:).*X(r,:).*expo)/phi)...
    -((mean(X(r,:).*expo)*mean(X(p,:).*X(q,:).*expo))+(mean(X(p,:).*expo)*mean(X(r,:).*X(q,:).*expo))+(mean(X(q,:).*expo)*mean(X(p,:).*X(r,:).*expo)))/(phi^2)...
    +2*mean(X(p,:).*expo)*mean(X(q,:).*expo)*mean(X(r,:).*expo)/(phi^3);

V(2)=(mean(X(p,:).*X(q,:).*Y(r,:).*expo)/phi)...
    -((mean(Y(r,:).*expo)*mean(X(p,:).*X(q,:).*expo))+(mean(X(p,:).*expo)*mean(Y(r,:).*X(q,:).*expo))+(mean(X(q,:).*expo)*mean(X(p,:).*Y(r,:).*expo)))/(phi^2)...
    +2*mean(X(p,:).*expo)*mean(X(q,:).*expo)*mean(Y(r,:).*expo)/(phi^3);

V(3)=(mean(Y(p,:).*Y(q,:).*Y(r,:).*expo)/phi)...
    -((mean(Y(r,:).*expo)*mean(Y(p,:).*Y(q,:).*expo))+(mean(Y(p,:).*expo)*mean(Y(r,:).*Y(q,:).*expo))+(mean(Y(q,:).*expo)*mean(Y(p,:).*Y(r,:).*expo)))/(phi^2)...
    +2*mean(Y(p,:).*expo)*mean(Y(q,:).*expo)*mean(Y(r,:).*expo)/(phi^3);

V(4)=(mean(Y(p,:).*Y(q,:).*X(r,:).*expo)/phi)...
    -((mean(X(r,:).*expo)*mean(Y(p,:).*Y(q,:).*expo))+(mean(Y(p,:).*expo)*mean(X(r,:).*Y(q,:).*expo))+(mean(Y(q,:).*expo)*mean(Y(p,:).*X(r,:).*expo)))/(phi^2)...
    +2*mean(Y(p,:).*expo)*mean(Y(q,:).*expo)*mean(X(r,:).*expo)/(phi^3);



