function S=create_symbols(const_type,nbs,nbo)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%create sources matrix for a given contellation type
%nbs is the number of sources and nbo the number of observations

M=str2double(const_type(1));


if const_type(2:end)=='psk'
    a=pskmod(0:M-1,M);
elseif const_type(2:end)=='qam'
    a=qammod(0:M-1,M);
elseif const_type(2:end)=='ask'
    a=pammod(0:M-1,M);
end

S=zeros(nbs,M^nbs);
for n=1:nbs
    j=1;temp=[];
    for k=1:M^n
        temp=[temp repmat(a(j),1,M^nbs/M^n)];
        j=j+1;
        if j==M+1
            j=1;
        end
    end
    S(n,:)=temp;
end
