function [M,Ind]=table_deriv(O);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

M=[2 0;1 1];
Ind=[1 2;1 2];
for i=3:O
    x=nb_termes(i);
    Ind1=zeros(x,i);
    M1=zeros(x,i);
    P=size(M,1);
    j=1;
    for p=1:P
        v=find(M(p,:)==0);
        if isempty(v)
            K=i;
        else
            K=v(1);
        end
        for k=1:K
            M1(j,1:end-1)=M(p,:);
           % if k~=K
                M1(j,k)=M1(j,k)+1;
           % else
            %    M1(j,end)=1;
           % end
            a=Ind(p,:);
            pos=sum(M1(j,1:k)) ;
            Ind1(j,:)=insere(a,pos,i);
            j=j+1;
        end
    end
    M=M1;
    Ind=Ind1;
end
end

function tn=insere(t,pos,num);
if pos<=length(t)
    tn=[t(1:pos-1) num t(pos:end)];
else
    tn=[t pos];
end
end

function nb=nb_termes(O);
n=[2];
for k=3:O
    n1=[];
    for i=1:length(n)
        n1=[n1 (n(i)*ones(1,n(i)-1)) n(i)+1];
    end
    n=n1;
end
nb=sum(n1);
end
