function g=construct_gradient(L,T)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I=size(T);
D=length(I);
nbs=size(L{1},2);
TT=T;
d=1:D;

g=zeros(sum(I)*nbs,1);

k=1;
for i=1:D
    
    d=circshift(d,[0,-1]);
    TT=permute(T,d);
    Td=reshape(TT,prod(I),1);
    
    Z1=ones(nbs);
    Z2=ones(1,nbs);
    for j=1:D-1
        Z1=hdp(L{d(j)}'*L{d(j)},Z1);    
        Z2=pkr(L{d(j)},Z2);
    end
         
    g(k:k-1+I(i)*nbs)= kron(I_(I(i)),Z1)*vec(L{d(end)}.')...
    - kron(I_(I(i)),Z2)'*Td;
    
    k=k + I(i)*nbs;

end


