function Tpsi=create_gfT_3(w,Z);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, André L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global expo
global observations
observations=Z;

expo=exp(real(w'*Z));
phi=mean(expo);
N=length(w);

for ii=1:2:2*N-1
    for j=1:2:2*N-1
        for k=1:2:2*N-1
            p=(ii+1)/2;
            q=(j+1)/2;
            r=(k+1)/2;
            Tpsi(ii:ii+1,j:j+1,k:k+1)=D([p q r])/phi-(nprod(D([p q]),D(r))+permute(nprod(D([p r]),D(q)),[1 3 2])+permute(nprod(D([q r]),D(p)),[3 1 2]))/phi^2+2*nprod(nprod(D(p),D(q)),D(r))/phi^3;
            
        end
    end
end


function T=D(ind);
global expo
global observations
X=real(observations);
Y=imag(observations);
T=0;
for n=1:size(X,2)  
    M=[(X(ind,n)).';(Y(ind,n)).'];
    T=nprod1(M)*expo(n)+T;
end
T=T/size(X,2);  








