function Tpsi=create_gfT_4(w,Z);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 	These codes belong to the CAF_toolbox.                          	%
% 	Authors: Xavier Luciani, Andr L.F. De Almeida and Pierre Comon 	%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global expo
global observations
observations=Z;

expo=exp(real(w'*Z));
phi=mean(expo);
N=length(w);

for ii=1:2:2*N-1
    for j=1:2:2*N-1
        for k=1:2:2*N-1
            for l=1:2:2*N-1
                p=(ii+1)/2;
                q=(j+1)/2;
                r=(k+1)/2;
                s=(l+1)/2;
                Tpsi(ii:ii+1,j:j+1,k:k+1,l:l+1)=D([p q r s])/phi ...                   
                      -(nprod(D([p q r]),D(s))+permute(nprod(D([p q s]),D(r)),[1 2 4 3])+permute(nprod(D([p r s]),D(q)),[1 4 2 3])+permute(nprod(D([q r s]),D(p)),[4 1 2 3]))/phi^2 ...                          
                      -(nprod(D([p q]),D([r s]))+permute(nprod(D([p r]),D([q s])),[1 3 2 4])+permute(nprod(D([q r]),D([p s])),[3 1 2 4]))/phi^2 ...                        
                      +2*(nprod(nprod(D([p q]),D(r)),D(s))+permute(nprod(nprod(D([p r]),D(q)),D(s)),[1 3 2 4])+permute(nprod(nprod(D([q r]),D(p)),D(s)),[3 1 2 4])+permute(nprod(nprod(D([s p]),D(q)),D(r)),[2 3 4 1])+permute(nprod(nprod(D([q s]),D(r)),D(p)),[4 1 3 2])+permute(nprod(nprod(D([r s]),D(p)),D(q)),[3 4 1 2]))/phi^3 ...                         
                      -6*(nprod(nprod(nprod(D(p),D(q)),D(r)),D(s)))/phi^4;
            end
        end
    end
end


function T=D(ind);
global expo
global observations
X=real(observations);
Y=imag(observations);
T=0;
for n=1:size(X,2)  
    M=[(X(ind,n)).';(Y(ind,n)).'];
    T=nprod1(M)*expo(n)+T;
end
T=T/size(X,2); 

    








